function onHelp()
{
  window.open('cannyEdgeDetectionFilterHelp.html','cannyEdgeDetectionFilterHelp','menubar=no,width=800,resizable=yes,toolbar=no,location=no,directories=no,status=no');
}

function onLoad()
{
  
  // extract threshold filter options into variables
  window.cannyEdgeDetectionFilter = window.arguments[0].cannyEdgeDetectionFilter;

  // set up preview window
  window.previewWindow = new previewWindow(window.cannyEdgeDetectionFilter,"window.previewWindow")

  var variance = window.cannyEdgeDetectionFilter.variance;
  var maximumError = window.cannyEdgeDetectionFilter.maximumError;
  var upperThreshold = window.cannyEdgeDetectionFilter.upperThreshold;
  var lowerThreshold = window.cannyEdgeDetectionFilter.lowerThreshold;
 
  // create objects to reference the sliders 
  var varianceSlider = document.getElementById("variance-slider");
  var maximumErrorSlider = document.getElementById("maximum-error-slider");
  var upperThresholdSlider = document.getElementById("upper-threshold-slider");
  var lowerThresholdSlider = document.getElementById("lower-threshold-slider");

  // set inital position of sliders
  varianceSlider.setAttribute("curpos",variance);
  maximumErrorSlider.setAttribute("curpos",maximumError);
  upperThresholdSlider.setAttribute("curpos",upperThreshold);
  lowerThresholdSlider.setAttribute("curpos",lowerThreshold);  
  
  // set initial values of textboxes
  document.getElementById("variance-textbox").setAttribute("value",variance);
  document.getElementById("maximum-error-textbox").setAttribute("value",maximumError);
  document.getElementById("upper-threshold-textbox").setAttribute("value",upperThreshold);
  document.getElementById("lower-threshold-textbox").setAttribute("value",lowerThreshold);

  // add listeners to the sliders
  varianceSlider.addEventListener("DOMAttrModified", variance_slider, false);
  maximumErrorSlider.addEventListener("DOMAttrModified", maximum_error_slider, false);
  upperThresholdSlider.addEventListener("DOMAttrModified", upper_threshold_slider, false);
  lowerThresholdSlider.addEventListener("DOMAttrModified", lower_threshold_slider, false);

  // refocus window so that fragmented image updates
  // note we have to delay as the window is not actually drawn until AFTER the onload
  // function is executed
  
  setTimeout('self.focus()',20);
  
}

function onCancel() {
  window.previewWindow.destroyPreviewWindow();
}


// Called once if and only if the user clicks OK
function onOK() {
  // Return the changed arguments.
  // Notice if user clicks cancel, window.arguments[0].out remains null
  // because this function is never called

  // get values of textboxes
  var variance = document.getElementById("variance-textbox").value;
  var maximumError = document.getElementById("maximum-error-textbox").value;
  var upperThreshold = document.getElementById("upper-threshold-textbox").value;
  var lowerThreshold = document.getElementById("lower-threshold-textbox").value;

  window.cannyEdgeDetectionFilter.variance = variance;
  window.cannyEdgeDetectionFilter.maximumError = maximumError;
  window.cannyEdgeDetectionFilter.upperThreshold = upperThreshold;;
  window.cannyEdgeDetectionFilter.lowerThreshold = lowerThreshold;
  
  window.cannyEdgeDetectionFilter.apply_filter();
  
  // update preview window
  window.previewWindow.onPreview();

  return false;
}

function variance_slider()
{
  window.cannyEdgeDetectionFilter.variance = update_text_slider("variance-textbox","variance-slider",0,50);
  window.previewWindow.autoPreview();
}

function maximum_error_slider()
{
  window.cannyEdgeDetectionFilter.maximumError = update_text_slider("maximum-error-textbox","maximum-error-slider",.001,.999);
  window.previewWindow.autoPreview();
}

function upper_threshold_slider()
{
  window.cannyEdgeDetectionFilter.upperThreshold = update_text_slider("upper-threshold-textbox","upper-threshold-slider",0,.1);
  window.previewWindow.autoPreview();
}

function lower_threshold_slider()
{
  window.cannyEdgeDetectionFilter.lowerThreshold = update_text_slider("lower-threshold-textbox","lower-threshold-slider",0,.1);
  window.previewWindow.autoPreview();
}


function update_text_slider(textboxId,sliderId,minValue,maxValue)
{

  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

  // get current value
  var currentValue = document.getElementById(textboxId).value;			
  
  // fetch the weight slider that matches up to the slider element id
  var slider = document.getElementById(sliderId);
  
  // These attributes must be specified in the xul so that they are fetchable
  slider.maxValue = slider.getAttribute("maxpos");
  slider.value = slider.getAttribute("curpos");
  
  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (slider.previousValue != slider.value) {
    
    // slider value has changed so update the current value
    slider.previousValue = slider.value;
    
    // generate value between minValue and maxValue based on slider position
    currentValue = minValue + (maxValue - minValue) * slider.value / slider.maxValue;
    
    // assign weightVariable to have generated weight
    // there are only 3 possible values for weightVariable
    // as we check the colour it should be impossible to generate an incorrect or malicious value
      
    // update text box
    document.getElementById(textboxId).setAttribute("value",currentValue);			
    
  }
  return currentValue;
}

