
// constructor 
function previewSceneReady(previewWindow)
{
	this.previewWindow = previewWindow;
}

previewSceneReady.prototype =
{
  QueryInterface: function(aIID)
  {
    if (
        aIID.equals(Components.interfaces.CmguiISceneViewerResultMonitor)
       )
    {
      return this;
    }
    throw Components.results.NS_NOINTERFACE;
  },

	sceneViewerReady: function(sceneViewer)
  {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

		this.previewWindow.previewViewer = sceneViewer;

	}

};

// constructor
function previewWindow(filter,previewWindowVariableName)
{

	this.filter = filter;
	this.previewWindowVariableName = previewWindowVariableName;
	this.commandData = filter.commandData;
	this.fullsizeViewer = filter.sceneViewer;
	this.previewgElementName = filter.gElementName;
	this.inputFieldName = filter.inputFieldName;
	this.previewOutputFieldName = filter.previewOutputFieldName;
	this.previewResolution = filter.previewResolution;

	this.setupXULpreviewElements();

	var	inputFieldName = this.inputFieldName;
	var previewOutputFieldName = this.previewOutputFieldName;

	//	this.commandData = commandData;
	//	this.fullsizeViewer = sceneViewer;
	//	this.previewgElementName = gElementName;
	//	this.inputFieldName = inputFieldName;
	//	this.previewOutputFieldName = previewOutputFieldName;

	this.sceneName = previewOutputFieldName + "_scene";
	this.textureName = previewOutputFieldName + "_texture";
	this.materialName = previewOutputFieldName + "_material";

	this.inputTextureName = inputFieldName + "_texture";
	this.inputMaterialName = inputFieldName + "_material";

	this.previewSliceCoordinatesName = previewOutputFieldName + "_slice_coords";
	this.previewOffsetSliceCoordinatesName = previewOutputFieldName + "_offset_slice_coords";
	this.prev_ndc_invName = previewOutputFieldName + "_prev_ndc_inv";
	
	//	this.previewViewer = null;
	//	window.alert("gelemet name is " + this.previewgElementName + "\nscene name is " + this.sceneName);

	// create scene and set scene viewer into window
  zincCreateSceneViewer(document.getElementById("PreviewWindow"),
												this.commandData, new previewSceneReady(this));	 


	//	this.previewViewer = window.previewViewer;
	this.initialiseSceneViewer();


}

previewWindow.prototype =
{

	// members
	
	filter: null,
	commandData: null,
	fullsizeViewer: null,
	previewgElementName: null,
	previewOutputFieldName: null,
	previewViewer:null,
	sceneName: null,
	textureName: null,
	materialName: null,
	previewSliceCoordinatesName: null,
	previewOffsetSliceCoordinatesName: null,
	prev_ndc_invName: null,
	inputFieldViewed: "false",

	// handleEven is used to update the preview resolution value when the slider is moved
	// Originally a function preview_resolution_slider was used but the event is now being 
	// handled through passing the instance of the preview window object to the addEventListener function.
	// this means the preview window object requires a handleEvent function to handle the events
	// listened to
	handleEvent: function()
{

  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var previewResolutionSlider = document.getElementById("preview-resolution-slider");

  // These attributes must be specified in the xul so that they are fetchable
  previewResolutionSlider.value = previewResolutionSlider.getAttribute("curpos");
  previewResolutionSlider.maxValue = previewResolutionSlider.getAttribute("maxpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (previewResolutionSlider.previousValue != previewResolutionSlider.value)
    {
			
      previewResolutionSlider.previousValue = previewResolutionSlider.value;
			var resolution = Math.pow(2,previewResolutionSlider.value);

      // update text box
			var resolutionString = resolution + "x" + resolution;
      document.getElementById("preview-resolution-textbox").setAttribute("value",resolutionString);
		
			// update the preview
			this.filter.previewResolution = resolution;
			this.filter.resample_preview();
			this.autoPreview();
		}

},

// set up the preview window and associate controls
  setupXULpreviewElements: function()
{
	// extract values required for the preview window
	var commandData = this.commandData;
	var fullsizeViewer = this.sceneViewer;
	var previewgElementName = this.gElementName;
	var inputFieldName = this.inputFieldName;
	var previewOutputFieldName = this.previewOutputFieldName;
	var previewResolution = this.previewResolution;

	// set up preview controls
	var previewResolutionSlider = document.getElementById("preview-resolution-slider");
	
	// note that the following code will NOT work:
	//   previewResolutionSlider.addEventListener("DOMAttrModified",this.preview_resolution_slider, false);
	// within the preview_resolution_slider function the this attribute will refer 
	// to the previewResolutionSlider object rather than the instance of the previewWindow object
	// One workaround is to pass an anonymous function as the callback:  
	//   previewResolutionSlider.addEventListener("DOMAttrModified",function() { instance.preview_resolution_slider(); }, false);
	// This works but I am worried about memory leaks as a result of the closure from using an inner function
	// Instead I have added a HandleEvent function to the previewWindow object and am passing in an instance
	// of the previewWindow object
	var instance = this;
	previewResolutionSlider.addEventListener("DOMAttrModified", instance, false);

	// set slider position based on current resolution
	var resolutionCurpos = Math.log(previewResolution)/Math.log(2);
  previewResolutionSlider.setAttribute("curpos",resolutionCurpos);

	// display current resolution in textbox
	var resolutionString = previewResolution + "x" + previewResolution;
	document.getElementById("preview-resolution-textbox").setAttribute("value",resolutionString);

	// can we set the oncommand attribute to call the autoPreview function belonging to this object?
	var autoPreviewFunctionName = this.previewWindowVariableName + ".autoPreview();"
	document.getElementById('auto-preview-checkbox').setAttribute("oncommand",autoPreviewFunctionName);

	var onPreviewFunctionName = this.previewWindowVariableName + ".onPreview();"
	document.getElementById('preview-button').setAttribute("oncommand",onPreviewFunctionName);

	var onViewInputImageFunctionName = this.previewWindowVariableName + ".viewInputImage();"
	document.getElementById('view-input-checkbox').setAttribute("oncommand",onViewInputImageFunctionName);

},

	autoPreview: function() 
{

	if (document.getElementById("auto-preview-checkbox").getAttribute("checked") == "true") {
		this.onPreview();
	}
},
	
	onPreview: function() 
{

	// run the input_image field through an image_resample filter 
	// to get a smaller image to use for previewing results
	
	this.filter.preview_filter();

	// display the preview image rather than the input image
	document.getElementById("view-input-checkbox").setAttribute("checked","false");
	this.displayInputImage("false");
	this.redisplayPreviewWindow();
	
},

  viewInputImage: function() 
{

	// if checked display view input image
	var displayInput = document.getElementById("view-input-checkbox").getAttribute("checked");
	this.displayInputImage(displayInput);

},


// destroys the scene and the coordinate fields associated with viewing the material
	destroyPreviewWindow: function()
{

	// inputs required
	var previewViewer = this.previewViewer;
	var commandData = this.commandData;
	var previewgElementName = this.previewgElementName;
	var previewOutputFieldName = this.previewOutputFieldName;

	// first change the scene viewer to view something else so that we can destroy the preview scene
	previewViewer.setSceneByName("default");

	// remove graphics objects
	//	this.commandData.executeCommand("gfx mod g_element texture_block lines delete scene " + this.sceneName);
	commandData.executeCommand("gfx mod g_element " + previewgElementName + " surfaces as digitise_surface delete scene " + this.sceneName);
	commandData.executeCommand("gfx destroy mat " + this.materialName);
	commandData.executeCommand("gfx destroy texture " + this.textureName);

	// if the input field has been viewed then a material and texture was
	// created so we need to delete them
	if (this.inputFieldViewed == "true") {
		commandData.executeCommand("gfx destroy mat " + this.inputMaterialName);
		commandData.executeCommand("gfx destroy texture " + this.inputTextureName);
	}
	
	// remove preview_scene 
	commandData.executeCommand("gfx destroy scene " + this.sceneName);

	// remove prev_ndc_inv and dependent fields
	commandData.executeCommand("gfx destroy field " + previewOutputFieldName);
	commandData.executeCommand("gfx destroy field " + this.previewSliceCoordinatesName);
	commandData.executeCommand("gfx destroy field " + this.previewOffsetSliceCoordinatesName);
	commandData.executeCommand("gfx destroy field " + this.prev_ndc_invName);

},


// set up the preview scene
	initialiseSceneViewer: function()
{

	// inputs required
	var commandData = this.commandData;
	var previewViewer = this.previewViewer;
	var previewgElementName = this.previewgElementName

	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

	commandData.executeCommand("gfx create scene " + this.sceneName + ";");
	commandData.executeCommand("gfx modify scene " + this.sceneName + " manual;");
			
	this.previewViewer.setSceneByName(this.sceneName);
	
	// draw the element that will have the material placed on it
	commandData.executeCommand("gfx draw group texture_block scene " + this.sceneName);
	commandData.executeCommand("gfx modify g_element texture_block general default_coordinate volumeCoordinates scene "  + this.sceneName);
	commandData.executeCommand("gfx modify g_element texture_block lines scene "  + this.sceneName);

	// draw the material

	commandData.executeCommand("gfx draw group " + previewgElementName + " scene " + this.sceneName + ";");
	commandData.executeCommand("gfx modify g_element " + previewgElementName + " general default_coordinate window_coordinates scene " + this.sceneName + ";");


	// set scene view parameters to match that of the fullsized scene view passed in
	this.setSceneViewParameters();

	this.createPreviewFields();

},


  displayInputImage: function(displayInput)
	{


		if(displayInput == "true") {

			// if the input field has not yet been viewed create the required fields
			if(this.inputFieldViewed == "false") {
				this.createInputFields();
				this.inputFieldViewed = "true";
			}

			this.commandData.executeCommand("gfx modify g_element " + this.previewgElementName + " surfaces as digitise_surface material " + this.inputMaterialName + " texture_coordinates " + this.previewSliceCoordinatesName + " scene " + this.sceneName + ";");
		}
		else {

			this.commandData.executeCommand("gfx modify g_element " + this.previewgElementName + " surfaces as digitise_surface material " + this.materialName + " texture_coordinates " + this.previewSliceCoordinatesName + " scene " + this.sceneName + ";");
		}
	},



  redisplayPreviewWindow: function()
{

	// inputs required
	var commandData = this.commandData;
	var previewOutputFieldName = this.previewOutputFieldName

	commandData.executeCommand("gfx modify texture " + this.textureName + " nearest width 1 height 1 evaluate_image field " + previewOutputFieldName + " spectrum gray_spectrum texture_coord xi element_group digitise_plane;");

},


// set the view point so that the preview g element is displayed correctly
	setSceneViewParameters: function() {

	// inputs required
	var fullsizeViewer = this.fullsizeViewer;
	var previewViewer = this.previewViewer;


	// FETCH parameters used to check them
	var ex = {}, ey = {}, ez = {}, lx = {}, ly = {}, lz = {};
	var ux = {}, uy = {}, uz = {};
	fullsizeViewer.getLookatParameters(ex, ey, ez, lx, ly, lz, ux, uy, uz);

	var nearPlane = {}, farPlane = {};
	fullsizeViewer.getNearAndFarPlane(nearPlane, farPlane );

	// set up view according to fetched view parameters
	previewViewer.setLookatParametersNonSkew(ex.value, ey.value, ez.value, lx.value, ly.value, lz.value, ux.value, uy.value, uz.value);
	previewViewer.setNearAndFarPlane(nearPlane.value, farPlane.value);
	previewViewer.viewAngle = fullsizeViewer.viewAngle;

	// set background colour to red.  
	// If there as an error previewing the imageit is easy to tell something 
	// has gone wrong as a red background will be shown
	previewViewer.setBackgroundColourRGB(1.0, 0.0, 0.0);

	// make the scene 2D
	previewViewer.tumbleRate = 0;

},


	createInputFields: function()
	{

		var commandData = this.commandData;
		var inputFieldName = this.inputFieldName;

		commandData.executeCommand("gfx create texture " + this.inputTextureName + " width 1 height 1 border_clamp;");
		
		commandData.executeCommand("gfx modify texture " + this.inputTextureName + " nearest width 1 height 1 evaluate_image field " + inputFieldName + " spectrum gray_spectrum texture_coord xi element_group digitise_plane;");
		
		try {
		  commandData.executeCommand("gfx create material " + this.inputMaterialName + " texture " +
		    this.inputTextureName + 
		  " per_pixel_mode colour_lookup_spectrum colour_lookup colour_lookup_red colour_lookup_green colour_lookup_blue;");
		} catch (ex) {
		  commandData.executeCommand("gfx create material " + this.inputMaterialName + " texture " +
		    this.inputTextureName + 
		  " normal colour_lookup_spectrum none;");		  
		}

	},



	createPreviewFields: function()
{

	// inputs required
	var commandData = this.commandData;
	var previewOutputFieldName = this.previewOutputFieldName;
	var previewgElementName = this.previewgElementName;
	var previewViewer = this.previewViewer;

	var preview_coordinate_field = commandData.findFieldByName("normalisedCoordinates");	
	var prev_ndc_inv_field = commandData.createField(this.prev_ndc_invName);
	prev_ndc_inv_field.setTypeWindowProjectionField(preview_coordinate_field,previewViewer, Components.interfaces.CmguiIComputedField.INVERSE_NDC_PROJECTION,commandData);

	commandData.executeCommand("gfx define field " + this.previewOffsetSliceCoordinatesName + " add fields " + this.prev_ndc_invName + " sliceOffsets");
	commandData.executeCommand("gfx define field " + this.previewSliceCoordinatesName + " matrix_multiply number_of_rows 3 fields inverse_transform " + this.previewOffsetSliceCoordinatesName + ";");

	// create a texture
	commandData.executeCommand("gfx create texture " + this.textureName + " width 1 height 1 border_clamp;");
	
	// note we will need to allow for grayscale OR colour, just doing colour
	// to begin with	
	// should probably not rely on gray_spectrum existing!!!
	// create our own preview spectrum
		
	commandData.executeCommand("gfx modify texture " + this.textureName + " nearest width 1 height 1 evaluate_image field " + previewOutputFieldName + " spectrum gray_spectrum texture_coord xi element_group digitise_plane;");
		
	// create a material, not sure if we need to specify alpha
	// or whether any of the other options after the texture are necessary

	try {
	  commandData.executeCommand("gfx create material " + this.materialName + " texture " +
	  this.textureName + 
	  " per_pixel_mode colour_lookup_spectrum colour_lookup colour_lookup_red colour_lookup_green colour_lookup_blue;");
	} catch (ex) {
	  commandData.executeCommand("gfx create material " + this.inputMaterialName + " texture " +
	    this.inputTextureName + 
	    " normal colour_lookup_spectrum none;");		  
	}

	
	commandData.executeCommand("gfx modify g_element " + previewgElementName + " surfaces as digitise_surface material " + this.materialName + " texture_coordinates " + this.previewSliceCoordinatesName + " scene " + this.sceneName + ";");

},
	

// function to display view parameters using an alert
	checkSceneParameters: function() {

	var previewViewer = this.previewViewer;
	
	// FETCH parameters used to check them
	var ex = {}, ey = {}, ez = {}, lx = {}, ly = {}, lz = {};
	var ux = {}, uy = {}, uz = {};
	previewViewer.getLookatParameters(ex, ey, ez, lx, ly, lz, ux, uy, uz);

	var distance = Math.sqrt((ex.value - lx.value) * (ex.value - lx.value) +
		(ey.value - ly.value) * (ey.value - ly.value) + 
		(ez.value - lz.value) * (ez.value - lz.value));

	var nearPlane = {}, farPlane = {};
	previewViewer.getNearAndFarPlane(nearPlane, farPlane );

	window.alert("Digitise viewer lookat paramters are as follows:\n " +
							 "Eye x: " + ex.value + "\nEye y:" + ey.value + "\nEye z:" + ez.value + "\n" +
							 "Lookat x.value:" + lx.value + "\nLookat y:" + ly.value + "\nLookat z:" + lz.value + "\n" +
							 "Up x:" +ux.value + "\nUp y:" + uy.value + "\nUp z:" + uz.value + "\n" +
							 "near plane: " + nearPlane.value + "\nfar plane:" + farPlane.value);

		
}



} // end of prototype
